<template lang="pug">
  div.login.container
    el-row(justify="center" align="middle" type="flex")
      h1 #[span.highlight Coco]: The Auto-Gallery
    el-row( justify="center" align="middle" type="flex")
      el-row.login.card(justify="center" type="flex")
        el-card
          el-col
            el-row(justify="center" type="flex")
              p Please log in with Discord to continue.
            el-row(justify="center" type="flex")
              el-button(@click="login(false)" type="primary") #[i.bx.bxl-discord-alt] Log In
            el-divider Help
            div.help
              el-row(justify="center" type="flex")
                p Feel free to join our Discord guild #[a(href="https://discord.gg/aEUCHwX") #[el-button(type="primary" plain size="mini") here]] and ask.
              el-row(justify="center" type="flex")
                p If you need help with what setting does what in the channel pair settings, check #[NuxtLink(to="/help") #[el-button(type="primary" plain size="mini") here]].
            el-row(justify="center" align="middle" type="flex")
              el-divider Hello
            el-row(justify="center" align="middle" type="flex")
              el-card
                h2 What is Coco?
                p Coco is a platform that monitors select services (image boards) for new posts and sends them to your discord channel(s) via WebHooks.
                h2 Can I submit my own content?
                p Very likely, check the services we use for their post guidelines!
                h2 Is this a bot?
                p No. It just sends embeds via WebHooks.
                h2 Why do I need to log in?
                p We need to bind your settings to something, and since Discord is required for this anyway, it was easier to use that than to make a user system.
            el-row(justify="center" type="flex")
              el-divider Cheers~
</template>

<script lang="ts">
import Vue from 'vue'

import md5 from 'md5'
import Easter from '@/middleware/easter'

// Why is this a string?
// Cause it keeps complaining it's too big for an int.
const APP_ID = '872800959707873281'
const APP_CALL = `${window.location.protocol}//${window.location.hostname}/discord`
const APP_TYPE = 'code'
const APP_SCOPE = 'identify'

const easter = new Easter()

function generateToken () {
  let text = ''
  while (text.length < 1000) {
    const quoter = easter.pick()
    const addition = `${quoter.icon} ${quoter.name} ${quoter.quotes[Math.floor(Math.random() * quoter.quotes.length)]} ${Math.random()}`
    text += addition
  }
  return md5(text)
}

async function getUser (token: string) {
  const api = '/api/v1/user'
  return await fetch(api, {
    method: 'GET',
    headers: {
      Authorization: token
    }
  })
}

export default Vue.extend({
  mounted () {
    this.login(true)
  },
  methods: {
    async login (autoMode: boolean = false) {
      const existing = window.localStorage.getItem('coco_token')
      let doOAuth = true
      if (existing) {
        let user = null
        try {
          user = await (await getUser(existing)).json()
        } catch {
        }
        if (user) {
          doOAuth = false
          this.$router.push({ path: '/dashboard' })
        }
      }
      if (doOAuth && !autoMode) {
        const token = generateToken()
        window.localStorage.setItem('coco_token', token)
        const OA_URI = `https://discord.com/api/oauth2/authorize?client_id=${APP_ID}&redirect_uri=${APP_CALL}&response_type=${APP_TYPE}&scope=${APP_SCOPE}&state=${token}`
        window.location.href = OA_URI
      }
    }
  }
})
</script>

<style lang="scss" scoped>
.hidden {
  display: none;
}

// .login {
//   &.container {
//     margin: 1.5rem 0;
//   }
// }

.help {
  &.button {
    &:hover {
      color: #6040FF;
    }
  }
}

</style>
